/*
	Ejercicio 16, bloque 3: la Criba de Eratstenes es un algoritmo
	que permite hallar todos los nmeros primos menores que un
	nmero natural dado. Una forma simplificada es la siguiente:
	se visitan todos los nmeros comprendidos entre dos y el lmite
	superior, y si el nmero visitado es primo, se cuenta y se pone
	en consola. Se pueden ver dos variaciones del algoritmo bsico en:

	Prata, "A primer in C", pg. 261 - la multiplicin de
            enteros es ms rpida que la extraccin de races.

	Hernndez Yez "Fundamentos de programacin", pg.	222.
            excepto el nmero dos, los primos no son pares, as
            que probar slo con impares

	Fecha: 8/7/2019; 3:10 pm
	Revisin: 27/12/2019; 4:17 am
	S. Galliano, 2019
*/

#include "primo.h"
#include <iostream>
#include <cstdlib>
#include <cassert>

int long COL = 10;

int main() {
    using std::cout;
    using std::cin;
    cout << "Problema 16: criba de Erat\242stenes.\n"
    "Muestra y cuenta los primos entre dos y un l\241mite.\n\n";

    //  variable
	long i = 3,    // ndice
         num,      // lmite
         cant = 1; // cuenta

    //  entrada
    cout << "\250N\243mero? ";
    cin >> num;
    cout << '\n';
    if ( 0 > num ) {
        cout << "Los n\243meros primos son positivos.\n\n";
    } else if ( 0 == num ) {
        cout << "el cero no se contempla.\n\n";
    } else if ( 1 == num ) {
        cout << "El uno es no-primo.\n\n";
    } else if ( 2 == num ) {
        cout << "2 es primo.\n\n";
    } else {
        cout << "2\t";

        do {
            if ( esPrimo( i ) ) {
                cout << i;
                ++cant;

                if ( 0 == cant % COL ) {
                    cout << '\n';
                } else {
                    cout << '\t';
                } // if-else
            } // if

            ++i;
        } while ( i <= num );
    }

    cout << '\n';

    if ( 0 not_eq cant % COL ) {
        cout << '\n';
    } // if

    cout << "Son " << cant << " primos.\n\n";
    system ( "pause" );
    return EXIT_SUCCESS;
}
