//  nombre.cpp: definiciones para el ejercicio 22, bloque 4.
//  Fecha: 8:24 martes, 16 de abril de 2019
//  Revisin: 4/9/2020; 8:17 am
//  Por S. Galliano.

#include "cartas.h"
#include <iostream>
#include <iomanip>
#include <ctime>
#include <cstdlib>
#include <ios>
using std::cout;
using std::setw;
using std::ios_base;

//  funcin auxiliar: pone una lnea divisoria
void ponerLinea() {
    cout << std::left << std::setfill('-') <<
    setw(76) << std::right << '\n' << std::setfill(' ');
}

//  las figuras de la baraja
Str ponerPalo( int palo ) {
    Str resp = "bastos";

    if ( palo == oros    ) resp = "oros";
    if ( palo == copas   ) resp = "copas";
    if ( palo == espadas ) resp = "espadas";

    return resp;
}

//  los nmeros de la baraja
Str ponerValor( int numero ) {
    Str resp = "Rey de ";

    if ( numero == as      ) resp = "As de ";
    if ( numero == dos     ) resp = "Dos de ";
    if ( numero == tres    ) resp = "Tres de ";
    if ( numero == cuatro  ) resp = "Cuatro de ";
    if ( numero == cinco   ) resp = "Cinco de ";
    if ( numero == seis    ) resp = "Seis de ";
    if ( numero == siete   ) resp = "Siete de ";
    if ( numero == sota    ) resp = "Sota de ";
    if ( numero == caballo ) resp = "Caballo de ";

    return resp;
}

//  carga un mazo de cartas
void cargar ( Str baraja[] ) {
    //  cargar la baraja
    for ( int i = 0; i < MAZO; ++i ) {
        for ( int palo = oros; palo <= bastos; ++palo ) {
            for ( int numero = as; numero <= rey; ++numero ) {
                baraja[i] = ponerValor(numero) + ponerPalo(palo);
                ++i; // avanza a la prxima carta
            } // for
        } // for
    } // for
}

//  carga un mazo y lo deja barajado
void barajar( Str baraja[] ) {
    srand(time(0)); // garantiza distintas secuencias por ejecucin

    //  barajar
    for ( int i = MAZO - 1, az; i > 0; --i ) {
        az = rand() % MAZO;
        Str tmp = baraja[az];
        baraja[az] = baraja[i];
        baraja[i] = tmp;
    } // for
}

//  reparte la baraja entre 4 jugadores
void repartir( const Str baraja[] ) {
    //  encabezamiento de la tabla
    int ancho = 19;

    for ( int i = 0; i < PALOS; ++i) {
        cout << "Jugador " << i + 1 << setw(ancho - i);
    } // for

    cout << '\n';

    //  cuerpo de la tabla
    ponerLinea();
    cout << std::left;

    for ( int i = 0; i < MAZO; ++i ) {
         cout << setw(19) << baraja[i];

        if (i == MAZO - 1) {
            cout << '\n';
        } else if (0 == (i + 1) % PALOS) {
            cout << '\n';
        } // if-en-cascada
    } // for

    ponerLinea();
}
