//  vectores.cpp: definiciones para el ejercicio 23, bloque 4.
//  Fecha: 2:44 pm; mircoles, 17 de abril de 2019
//  Revisin: 4/9/2020; 8:21 am
//  Por S. Galliano.

#include "vectores.h"
#include <iostream>
#include <cstdlib>
#include <sstream>
#include <cmath>
#include <iomanip>
using std::cout;
using std::cin;

Vector::Vector( double x, double y ) {
    a = x;
    b = y;
}

void Vector::entrar( Str id ) {
    cout << "Vector " << id << " en formato (x,y): ";
    cin.ignore( 1 ) >> a; // ignora '(' - 1 carcter
    cin.ignore( 1 ) >> b; // ignora ',' - 1 carcter

    // en el bfer de entrada quedan restos: eliminar hasta
    // el ltimo carcter contenido en el bfer
    while ( cin.get() not_eq '\n' ) {
        continue;
    } // while
}

void Vector::mostrar( Str id ) {
    cout << "Vector " << id << " (" << a << "," << b << ")\n";
}

//  pPto = (a1 * b1 + a2 * b2)
double Vector::pPunto( Vector B ) {
    return ( a * B.a ) + ( b * B.b );
}

// N = raz(a2 + b2)
double Vector::calcNorma() {
    return sqrt( a * a + b * b );
}

//  cos = pPto/NA*NB
void Vector::calcCos( Vector B ) {
    sita = pPunto( B ) / ( calcNorma() * B.calcNorma() );
}

void Vector::mostrarCos() {
    double const RAD2GRAD = 57.285780;

    cout << std::fixed << std::setprecision( 3 ) << '\n'
         << "El \240ngulo entre A y B vale " << sita
         << " rad o " << std::setprecision( 1 ) << sita * RAD2GRAD << " grados.\n";

    if ( 0 == sita ) {
        cout << "Son perpendiculares.\n";
    } else if ( 1 == sita ) {
        cout << "Son  paralelos.\n";
    } else if ( -1 == sita ) {
        cout << "Son anti-paralelos.\n";
    } // if-en-cascada

    cout << '\n';
}
