// conversion.cpp: definiciones para el ejercicio 26, bloque 4.
// Fecha: 23/11/2019; 8:38 am
// Revisin: 4/9/2020; 9:10 am
// S. Galliano.
#include "conversion.h"
#include "menu.h"
#include <iostream>
#include <ios>
#include <iomanip>
#include <cmath>

//  dispone todos los valores
void Conver::factorizar( short opcion, double valor ) {
    //  el final no se procesa
    if ( fin == opcion ) {
        return;
    } // if

    //  entrando valores a la estructura
    opc = opcion;
    val = valor;

    switch ( opcion ) {
    case volLiq:
        uniEN = "gal";
        uniMT = "L  ";
        k = 3.785412;
        break;
    case volSol:
        uniEN = "ft3";
        uniMT = "m3 ";
        k = 0.028317;
        break;
    case masa:
        uniEN = "lb";
        uniMT = "kg";
        k = 0.45359284;
        break;
    case area:
        uniEN = "ac";
        uniMT = "ha";
        k = 0.40468564;
        break;
    case largo:
        uniEN = "mi";
        uniMT = "km";
        k = 1.609344;
        break;
    case temp:
        uniEN = "F";
        uniMT = "C";
        k = 32.0;
        break;
    case ang:
        uniEN = "rad  ";
        uniMT = "grado";
        k = 57.2957795;
        break;
    } // switch

    if ( temp == opcion ) {
        valMT = ( val - k ) / 1.8;
        valEN = 1.8 * val + k;
    } else {
        valEN = val / k;
        valMT = val * k;
    } // if-en-cascada

    // eliminar las vueltas completas
    if ( ang == opcion and valMT > 360.0 ) {
        valMT = fmod( valMT, 360.0 );
    } // if
}

void Conver::mostrar() const {
    int ancho   = 8;
    int decimal = 4;

    std::ios::fmtflags oldFlags = std::cout.flags(); // formato original
    // formato deseado
    std::cout << setiosflags( std::ios::fixed | std::ios::showpoint ) <<
    std::setprecision( decimal );

    //  primera lnea a consola
    std::cout << '\n' <<
    std::setw( ancho )  << val   << ' ' << uniEN << " --> " <<
    std::setw( ancho )  << valMT << ' ' << uniMT;

    //  segunda lnea a consola
    std::cout << '\n' <<
    std::setw( ancho )  << val   << ' ' << uniMT << " --> " <<
    std::setw( ancho )  << valEN << ' ' << uniEN;

    std::cout.unsetf( std::ios::fixed | std::ios::showpoint );
    std::cout.flags( oldFlags ); // formato original restaurado
}
