// tabla.cpp: definiciones para el ejercicio 29, bloque 6
// Fecha: 16/11/2019; 8:35 pm
// Revisin: 4/9/2020; 9:42 am
// S. Galliano.

#include "tabla.h"
#include <iostream>
#include <ios>
#include <iomanip>
using std::string;
using std::cout;

//  pone una lnea simple o doble en consola de n caracteres
void ponerLinea( char tipo, int n ) {
    cout << std::setfill( tipo ) << std::setw( n ) << '\n' << std::setfill( ' ' );
}

//  pone las materias de la tabla
void encabezar( const string * pMats, int n ) {
    for ( int i = 0; i < n; ++i ) {
        cout << pMats[i] << '\t';
    } // for

    cout << '\n';
}

// pone las notas del alumno;
void ponerNotas( const int * pNotas, int n, int m ) {
    double total;
    cout << std::fixed << std::setprecision( 1 );

    for ( int i = 0; i < m; ++i ) {
        cout << "Al. " << i + 1 << '\t';
        total = 0;

        for ( int j = 0; j < n; ++j ) {
            total += pNotas[i * n + j];
            cout <<  pNotas[i * n + j] << '\t';
        } // for j

        cout << total / n << '\n';
    } // for i

    cout << std::setprecision( 0 );
}

//  pone el promedio de las notas
void ponerPromedio( const int * pNotas, int n, int m ) {
    double total;
    cout << std::fixed << std::setprecision( 1 ) << "Prom." << '\t';

    for ( int i = 0; i < n; ++i ) {
        total = 0;

        for ( int j = 0; j < m; ++j ) {
            total += pNotas[i + j * n];
        } // for j

        cout << total / m << '\t';
    } // for i

    cout << '\n';
}
