// Ejercico 30: ampliar el ATD complejo
// Fecha: 7:48 jueves, 25 de abril de 2019
// Revisin: 24/9/2020; 5:44 pm
// S. Galliano.

//  *****************************************************
//  Estipulaciones del ADT Complejo
//  Nombre:	Complejo
//  Por: S. Galliano
//  Fecha: mayo 13/2020
//  Propiedades: Puede hacer algo de aritmtica compleja
//  Operaciones:
//      determina si dos complejos son iguales,
//      calcula el mdulo y el conjugado de un complejo,
//      suma, resta multiplica y divide dos complejos.
//      y tambin lo hace con un escalar
//  *****************************************************

#include "complejo.h"
#include <iostream>
#include <cstdlib>
#include <iomanip>

int main() {
    //  informacin
    std::cout << "Problema 31: aritm\202tica compleja.\n\n";

    //  escalar
    double esc;
    //  pedido de memoria
    Complejo * ptrZ  = new Complejo,
    *ptrZ1 = new Complejo,
    *ptrZ2 = new Complejo;

    //  entrada
    std::cout << "Entrar datos en formato (a,b)\n";
    ptrZ1->entraNumero( "Complejo z1 = " ); // 1er. complejo
    ptrZ2->entraNumero( "Complejo z2 = " ); // 2do. complejo
    std::cout << "Escalar = ";
    std::cin >> esc;

    //  salida:
    std::cout << "\nEn formato z = a+bi\n";
    ptrZ1->fmtSuma( "z1 = " );
    ptrZ2->fmtSuma( "z2 = " );
    std::cout << "\nEn formato (Mod,Grad)\n";
    ptrZ1->fmtPolar( "z1 = " );
    ptrZ2->fmtPolar( "z2 = " );
    std::cout << '\n';

    //  operaciones:
    std::cout << "Conjugados:\n";
    *ptrZ = ptrZ1->conjugado(); ptrZ->fmtCoord( "~Z1 = " );
    *ptrZ = ptrZ2->conjugado(); ptrZ->fmtCoord( "~Z2 = " );

    std::cout << "\nIgualdad:\n";
    ( ptrZ1->esIgualQue( *ptrZ2 ) )
        ? std::cout << "z1 y z2 son iguales.\n"
        : std::cout << "z1 y z2 no son iguales.\n";

    std::cout << "\nOperaciones aritm\202ticas:\n";
    *ptrZ = ptrZ1->sumadoCon( *ptrZ2 ); ptrZ->fmtCoord( "(z1+z2) = " );
    *ptrZ = ptrZ1->restadoDe( *ptrZ2 ); ptrZ->fmtCoord( "(z1-z2) = " );
    *ptrZ = ptrZ1->multipCon( *ptrZ2 ); ptrZ->fmtCoord( "(z1*z2) = " );
    *ptrZ = ptrZ1->divideCon( *ptrZ2 ); ptrZ->fmtCoord( "(z1/z2) = " );

    std::cout << "\nOperaciones con un escalar:\n";
    *ptrZ = ptrZ1->sumadoCon( esc ); ptrZ->fmtCoord( "(e+z1) = " );
    *ptrZ = ptrZ1->restadoDe( esc ); ptrZ->fmtCoord( "(e-z1) = " );
    *ptrZ = ptrZ1->multipCon( esc ); ptrZ->fmtCoord( "(e*z1) = " );
    *ptrZ = ptrZ1->divideCon( esc ); ptrZ->fmtCoord( "(z1/e) = " );

    std::cout << "\nLos m\242dulos son:\n";
    double m1 = ptrZ1->modulo();
    double m2 = ptrZ2->modulo();
    std::cout << std::setprecision( 2 ) << std::fixed
              << "|z1| = " << m1 << "\n|z2| = " << m2 << "\n\n";
    //  fin
    delete ptrZ;
    delete ptrZ1;
    delete ptrZ2;
    system( "pause" );
    return EXIT_SUCCESS;
}
