//  nombre.cpp: definiciones para el ejercicio 33, sexto bloque
//  Fecha: 12/8/2019; 9:54 pm
//  Revisin: 5/9/2020; 10:54 am
//  Por S. Galliano.

#include "dulce.h"
#include "almacen.h"
#include <iostream>
#include <string>
#include <iomanip>
using std::cout;
using std::cin;
using std::setw;
using std::setfill;

//  funcin auxilar: pone una lnea doble
//  o simple, de 40 caracteres en consola
void ponerLinea( char ch ) {
    cout << setfill( ch ) << setw( 40 ) << '\n' << setfill( ' ' );
}

//  tres marcas en inventario
Almacen::Almacen() {
    item[0] = Dulce( "Mocha Munch", 0.9, 208 );
    item[1] = Dulce( "Krispy Krunch", 1.05, 411 );
    item[2] = Dulce( "Honey Beez",    1.25, 789 );
    item[3] = Dulce( "", 0, 0 );
    item[4] = Dulce( "", 0, 0 );
}

//  funcin auxiliar
int cuenta( const Dulce item[] ) {
    int ctd = 0;

    for( unsigned i = 0; i < N; i++ ) {
        if( item[i].marca not_eq "" ) {
            ctd++;
        } // if
    } // for

    return ctd;
}

//  arreglo lleno?
bool Almacen::aryLleno() {
    int ctd = cuenta( item );
    return ctd == ( N - 1 );
}

//  arreglo vaco?
bool Almacen::aryVacio() {
    int ctd = cuenta( item );
    return ctd == 0;
}

//  inventario a consola
void Almacen::mostrarInventario() {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    cout << "\nEn almac\202n:\n";
    ponerLinea( '=' );
    cout << "Marca\t\tPrecio\tStock\tCosto\n";
    ponerLinea( '-' );
    int cnt = 0, totC = 0;
    double costo, totP = 0;
    cout << std::fixed << std::setprecision( 2 );

    for( int i = 0; i < N; i++ ) {
        if( item[i].marca not_eq "" ) {
            costo = item[i].precio * item[i].inventario;
            totP += costo;
            totC += i;
            cout << std::left <<
            setw( 13 ) << item[i].marca  << std::right <<
            setw( 8 )  << item[i].precio <<
            setw( 8 )  << item[i].inventario <<
            setw( 8 )  << costo << '\n';
        } // if
    } // for

    cout << "Total" << std::setfill( '.' ) << setw( 32 ) << totP << "$\n";
    ponerLinea( '=' );
    ( 1 == totC )
        ? cout << "\nEn stock hay un producto.\n\n"
        : cout << "\nEn stock hay " << totC << " productos.\n\n";
}

//  la marca est ya?
bool Almacen::marcaEsta( Str mk ) {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    int esta = false;

    for( int i = 0; i < N; i++ ) {
        if( mk == item[i].marca ) {
            esta = true;
            break;
        } // if
    } // for

    return esta;
}

//  el 1er. ndice vaco
int Almacen::primerIdx() {
    int idx = -1;

    for( int i = 0; i < N; i++ ) {
        if( "" == item[i].marca ) {
            idx = i;
            break;
        } // if
    } // for

    return idx;
}

void Almacen::entrarNuevo() {
    if( true == aryLleno() ) {
        throw MA_SI;
    } // if

    Str mk;
    cout << "Entre la marca: ";
    getline( cin, mk );

    if( true == marcaEsta( mk ) ) {
        throw MA_SI;
    } else {
        double pr;
        cout << "Entre el precio: ";
        ( cin >> pr ).get();
        int ct;
        cout << "Entre la cantidad: ";
        ( cin >> ct ).get();
        int i = primerIdx();
        item[i].entrarDulce( mk, pr, ct );
        cout << HECHO;
    } // if-else
}

void Almacen::editarCantidad() {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    Str mk;
    cout << "Entre la marca: ";
    getline( cin, mk );

    if( false == marcaEsta( mk ) ) {
        throw MA_NO;
    } // if

    int i, ct;

    for( i = 0; i < N; ++i ) {
        if( mk == item[i].marca ) {
            break;
        } // if
    } // for

    cout << "\n En inventario = " << item[i].inventario
         << "\nNueva cantidad = ";
    ( cin >> ct ).get();
    item[i].inventario = ct;
    cout << HECHO;
}

void Almacen::editarPrecio() {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    Str mk;
    cout << "Entre la marca: ";
    getline( cin, mk );

    if( false == marcaEsta( mk ) ) {
        throw MA_NO;
    } // if

    int i;
    double pr;

    for( i = 0; i < N; ++i ) {
        if( mk == item[i].marca ) {
            break;
        } // if
    } // for

    cout << "\nPrecio actual = $" << item[i].precio
         << "\nNuevo precio  = $";
    ( cin >> pr ).get();
    item[i].precio = pr;
    cout << HECHO;
}

void Almacen::borrarDulce() {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    Str mk;
    cout << "Entre la marca: ";
    getline( cin, mk );

    if( false == marcaEsta( mk ) ) {
        cout << MA_NO;
    } else {
        for( int i = 0; i < N; ++i ) {
            if( mk == item[i].marca ) {
                item[i].borrarDulce();
                break;
            } // if
        } // for
    } // if-else

    cout << HECHO;
}

void Almacen::borrarBase() {
    if( true == aryVacio() ) {
        throw VACIA;
    } // if

    char sn;
    std::cout << "\250Vaciar el inventario? (s/n): ";
    std::cin >> sn;

    if ( 'S' == toupper( sn ) ) {
        for( int i = 0; i < N; ++i ) {
            item[i].borrarDulce();
        } // for
    } // if

    cout << HECHO;
}
