// Ejercicio 33, sptimo bloque: una pila
// Fecha 31/8/2019; 5:44 pm
// Revisin: 5/9/2020; 8:24 pm
// S. Galliano.

#include "menu.h"
#include "pila.h"
#include <iostream>
#include <cstdlib>
#include <string>

int main() {
    using std::cout;
    using std::cerr;
    std::string info( "Problema 34: manejo de una pila.\n\n" );
    Stack * tope = new ( std::nothrow ) Stack; // la pila en la tienda libre

    if ( nullptr == tope ) {
        cerr << "Falt\242 memoria.\n\n";
        return EXIT_FAILURE;
    }

    short opcion;
    int n;
    Item valor;

    while ( true ) {
        opcion = menu( info );

        if ( terminar == opcion ) {
            delete tope;
            return EXIT_SUCCESS;
        } else {
            n = tope->cantidad();
        } // if-else

        switch ( opcion ) {
        case ayudar:
            darAyuda( info );
            break;
        case apilar:
            cout << "\250Valor? ";
            ( std::cin >> valor ).get();
            if ( true == tope->apila( valor ) ) {
                cout << valor << " fu\202 apilado.\n\n";
            } else {
                cerr << "No pude apilar.\n";
            }
            break;
        case contar:
            if ( tope->estaVacia() ) {
                cerr << WARN;
            } else {
                ( 1 == n )
                ? cout << "Un nodo.\n\n"
                       : cout << n << " nodos.\n\n";
            } // if-else
            break;
        case ver:
            if ( false == tope->mirar( valor ) ) {
                cerr << WARN;
            } else {
                cout << "Cabeza = " << valor << "\n\n";
            } // if-else
            break;
        case desapilar:
            if ( false == tope->desapila( valor ) ) {
                cerr << WARN;
            } else {
                cout << valor << " fu\202 desapilado\n\n";
            }
            break;
        } // switch
        system( "pause" );
    } // while
}
