//  pila.cpp: definiciones para el ejercicio 33, sptimo bloque
//  Fecha 31/8/2019; 5:44 pm
//  Por S. Galliano.

#include "pila.h"

Stack::Stack() {
    tope = prox = nullptr;
    n = 0;
}

bool Stack::estaVacia() const {
    return nullptr == tope;
}

int Stack::cantidad() const {
    return n;
}

bool Stack::apila( Item val ) {
    Stack * nodo = new ( std::nothrow ) Stack;

    if ( nullptr == nodo ) {
        return false;
    }

    nodo->item = val;

    if ( nullptr == tope ) {
        nodo->prox = nullptr;
    } else {
        nodo->prox = tope;
    } // if-else

    tope = nodo;
    ++n;
    return true;
}

bool Stack::desapila( Item & item ) {
    if ( estaVacia() ) {
        return false;
    } // if

    Stack * p1 = tope;
    item = tope->item;

    if ( nullptr == p1->prox ) {
        tope = nullptr;
    } else {
        tope = p1->prox;
    } // if-else

    --n;
    delete p1;
    return true;
}

bool Stack::mirar( Item & item ) const {
    if ( estaVacia() ) {
        return false;
    } else {
        item = tope->item;
        return true;
    } // if-else
}
