//  cola.cpp: definiciones para el ejercicio 34, sptimo bloque
//  Fecha: 13/8/2019; 9:09 pm
//  Por S. Galliano.

#include "cola.h"
#include <iostream>
using std::cerr;

Queue::Queue() {
    tope = prox = nullptr;
    n = 0;
}

int Queue::cantidad() const {
    return n;
}

bool Queue::estaVacia() const {
    return nullptr == tope;
}

void Queue::encola ( Item item ) {
    Queue * nuevo = new Queue;
    nuevo->item = item;
    nuevo->prox = nullptr;

    if ( nullptr == tope ) { // lista vaca
        tope = nuevo;
    } else {
        Queue * p1 = tope;

        while ( p1->prox not_eq nullptr ) {
            p1 = p1->prox;
        } // while

        p1->prox = nuevo;
    } // if-else

    ++n;
}

bool Queue::desencola( Item & item ) {
    if ( estaVacia() ) {
        return false;
    } // if

    Queue * p1 = tope;
    item = p1->item;

    if ( nullptr == p1->prox ) {
        tope = nullptr;
    } else {
        tope = p1->prox;
    } // if-else

    --n;
    delete p1;
    return true;
}

Item Queue::cabeza() const {
    if ( estaVacia() ) {
        return -1;
    } else {
        return tope->item;
    } // if-else
}

Item Queue::cola() const {
    if ( estaVacia() ) { // lista vaca
        return -1;
    }

    Queue * p1 = tope;

    while ( p1->prox not_eq nullptr ) {
        p1 = p1->prox;
    } // while

    return p1->item;
}
