#ifndef COLA_H_INCLUDED
#define COLA_H_INCLUDED

//  cola.h: declaraciones para el ejercicio 34, sptimo bloque
//  Fecha: 13/8/2019; 9:09 pm
//  Por S. Galliano.

//  Nombres de los elementos tpicos de una cola
//  C++	    Programa	Accin
//  top	    tope        puntero al inicio de la pila
//  next	prox	    puntero al prximo nodo
//  enqueue	encola	    encolar un valor
//  dequeue	desencola   desencolar un valor
//  front	cabeza	    ver el valor de la cabeza
//  back	cola	    ver el valor de la cola
//  empty	estaVaca   true si est vaca
//  size	cantidad    cuenta los nodos

#include <string>

const std::string ADVIERTO( "Cola vac\241a.\n\n" );
const std::string HECHO( "\255Hecho!\n\n" );
const std::string FALLO( "Operaci\242n fallida.\n\n" );

typedef int Item;

struct Queue {
    Queue(); // constructor
    // mtodos
    int cantidad  () const;
    bool estaVacia() const;
    Item cabeza   () const;
    Item cola     () const;
    bool desencola( Item & item );
    void encola   ( Item item );
    //  miembros
    int n;               // cantidad de nodos
    Item item;           // valor de un nodo
    struct Queue * tope; // puntero a la cabeza de la cola
    struct Queue * prox; // puntero al prximo nodo
};

#endif // COLA_H_INCLUDED
