// lse.cpp: definiciones para el ejercicio 36, sptimo bloque
// Fecha: 13/8/2019; 5:35 am
// Revisin: 6/9/2020; 6:54 am
// Por S. Galliano.

#include "lse.h"
#include <iostream>
using std::cout;
typedef std::string Str;

Nodo::Nodo() {
    head = next = nullptr;
    n = 0;
}

bool Nodo::estaVacia() const {
    return nullptr == head;
}

int Nodo::cuentame() const {
    return n;
}

bool Nodo::enLista ( Item val ) const {
    bool yaEsta = false;

    for ( Nodo * p1 = head; p1 not_eq nullptr; p1 = p1->next ) {
        if ( val == p1->item ) {
            yaEsta = true;
            break;
        } // if
    } // for

    return yaEsta;
}

bool Nodo::borraNodo( Item val ) {
    if ( not enLista( val ) ) {
        return false;
    } // if

    Nodo * p1 = head;
    Nodo * p2 = nullptr;

    // p1 viaja por la lista y p2 le sigue
    while ( p1->item not_eq val ) {
        p2 = p1;       // pone a p2 sobre el nodo a borrar
        p1 = p1->next; // preserva la continuidad
    } // while

    if ( nullptr == p2 ) {
        head = p1->next; // si es el 1er. nodo, lo desancla de la cabeza
    } else {
        p2->next = p1->next; // y es otro nodo, lo desancla de la lista
    } // if-else

    --n;
    delete p1; // el nodo se elimina de memoria
    return true;
}

void Nodo::vaciaLista() {
    Nodo * p1;
    n = 0;

    while ( not estaVacia() ) {
        if ( head->next == nullptr ) { //  lleg al final
            delete head;
            head = nullptr;
        } else { //  quedan nodos; sigue borrndolos
            p1 = head;
            head = p1->next;
            delete p1;
        } // if-else
    } // while
}

void Nodo::adiciona( Item val ) {
    Nodo * p1 = head, *p2 = nullptr;
    Nodo * nuevo = new Nodo;
    nuevo->item = val;

    while ( p1 not_eq nullptr ) {
        if ( val < p1->item ) { // garantiza el orden
            nuevo->next = p1;
            ++n;

            if ( nullptr == p2 ) { // chequea que p2 no sea nulo
                head = nuevo;
            } else {
                p2->next = nuevo;
            } // if-else

            return; // lo insert; nos vamos
        } else {    // avanza los punteros
            p2 = p1;
            p1 = p1->next;
        } // if-else
    } // while

    // no insert? nuevo va al final de la lista.
    nuevo->next = nullptr;
    ++n;

    if ( nullptr == p2 ) { // chequea que p2 no sea nulo
        head = nuevo;
    } else {
        p2->next = nuevo;
    } // if-else
}

void Nodo::muestrame() const {
    if ( not estaVacia() ) {
        cout << "Lista: ";

        for ( Nodo * p1 = head; p1 not_eq nullptr; p1 = p1->next ) {
            cout << p1->item << ", ";
        } // for

        cout << "\b\b \n\n";
    } // if
}
