#ifndef BIBLIO_H_INCLUDED
#define BIBLIO_H_INCLUDED

//  biblio.h: declaraciones para el ejercicio 37, sptimo bloque
//  Fecha: 14/8/2019; 10 am
//  Revisin: 6/9/2020; 6:26 am
//  Por S. Galliano.

#include <string>
typedef std::string Str;
const Str ERR_V( "La lista est\240 vac\241a.\n\n" );
const Str ERR_N( "No est\240 en la lista.\n\n" );

//  funcin auxiliar para poner una ID en maysculas
//  input: la ID
//  output: la ID est en maysculas
void toUpper( Str &ID );

//    Fundamentos del diseo:

//  Cada obra tiene el apellido del autor, nombre del autor,
//  ttulo de su obra y un identificador nico. Cada obra
//  sabe entrar un dato y mostrar un dato
struct Obra {
    //  constructor por defecto
    void entrarDato ();
    void mostrarDato();
    //  miembros
    Str nombre;
    Str apellido;
    Str titulo;
    Str id;
}; // Obra

//  Cada biblioteca tiene un listado de sus obras, sabe entrar
//  una obra, mostrarlas, buscar una obra, eliminar una obra o
//  eliminarlas todas, contarlas y vaciarse; adems puede
//  decir si est vacia, o si una obra ya est listada.
struct Biblio {
    Biblio(); // constructor
    // mtodos auxiliares
    bool estaVacia  () const;
    bool estaEnLista( Str val ) const;
    //  mtodos
    int  contarObras  () const;
    void mostrarBiblio() const;
    void mostrarObras ( Str ID ) const;
    void vaciarBiblio ();
    void entrarObra   ();
    void borrarObra   ( Str ID );
    //  miembros
    int n;                // cantidad de obras
    Obra obra;            // valor de una partida
    struct Biblio * head; // cabeza
    struct Biblio * prox; // puntero al prximo nodo
}; // Biblio

#endif // BIBLIO_H_INCLUDED
