// Ejercicio 37, sptimo bloque: una biblioteca.
// Fecha: 14/8/2019; 9:44 am
// Revisin: 6/9/2020; 6:26 am
// S. Galliano

#include "menu.h"
#include "biblio.h"
#include <iostream>
#include <cstdlib>

int main() {
    std::string info( "Problema 36: manejo de una biblioteca.\n\n" );
    Biblio *pObra = new Biblio;
    Str id;
    short opcion;
    int n;

    while ( true ) {
        opcion = menu( info );

        if ( terminar == opcion ) {
            delete pObra;
            return EXIT_SUCCESS;
        } // if

        n = pObra->contarObras();

        switch ( opcion ) {
        case ayudar:
            darAyuda(info);
            break;
        case insertar:
            pObra->entrarObra();
            std::cout << "Obra entrada.\n\n";
            break;
        case imprimir:
            if ( pObra->estaVacia() ) {
                std::cerr << ERR_V;
            } else {
                std::cout << "ID  Obras\n";
                pObra->mostrarBiblio();
            } // if-else
            break;
        case enumerar:
            if ( pObra->estaVacia() ) {
                std::cerr << ERR_V;
            } else {
                ( 1 == n )
                    ? std::cout << "Una obra.\n\n"
                    : std::cout << n << " obras.\n\n";
            } // if-else
            break;
        case buscar:
            if ( pObra->estaVacia() ) {
                std::cerr << ERR_V;
            } else {
                std::cout << "Entre un ID: ";
                std::getline( std::cin, id );
                toUpper(id);

                if ( pObra->estaEnLista(id) ) {
                    pObra->mostrarObras(id);
                } else {
                    std::cout << ERR_N;
                } // if-else
            } // if-else
            break;
        case eliminar:
            if ( pObra->estaVacia() ) {
                std::cerr << ERR_V;
                break;
            } // if

            std::cout << "Entre un ID: ";
            std::getline ( std::cin, id );
            toUpper(id);

            if ( pObra->estaEnLista(id) ) {
                pObra->borrarObra(id);
                std::cout << "Hecho.\n\n";
            } else {
                std::cerr << ERR_N;
            } // if-else
            break;
        case vaciar:
            if ( pObra->estaVacia() ) {
                std::cout << ERR_V;
            } else {
                char procedo;
                std::cout << "Se vaciar\240 la biblioteca.\n"
                             "\250Procedo? (s/n) ";
                std::cin >> procedo;

                if ( procedo == 'n' or procedo == 'N' ) {
                    break;
                } // if

                pObra->vaciarBiblio();
                std::cout << "Hecho.\n\n";
            } // if-else
            break;
        } // switch
        system ( "pause" );
    } // while
}
