// Ejercicio 40, noveno bloque
// Fecha: 16/08/2019; 11:49 am
// Revisin: 6/9/2020; 8:30 am
// S. Galliano.

#include "menu.h"
#include "nomina.h"
#include <iostream>
#include <fstream>
#include <cstdlib>

int main() {
    using std::cout;
    using std::cerr;
    using std::cin;

    std::ofstream Escribir( "C:/temp/BD/nomina.txt" );
    Nomina * pNom = new Nomina;
    std::string nomb, apel;
    int n, horas;
    std::string info ( "Problema 40: N\242mina de la CPA Santos Garc\241a.\n\n" );
    unsigned opcion;

    while ( true ) {
        opcion = menu( info );

        if ( opcion == terminar ) {
            delete pNom;
            return EXIT_SUCCESS;
        } else {
            n = pNom->contarRecords();
        } // if-else

        switch ( opcion ) {
        case ayuda:
            darAyuda( info );
            break;
        case insertar:
            while ( true ) {
                system( "cls" );
                cout << "Entre el nombre, luego el apellido y por \243ltimo\n"
                     "las horas trabajadas. Entre un cero en el nombre\n"
                     "para terminar.\n\nNombre: ";
                std::getline( cin, nomb );

                if ( isdigit( nomb[0] ) ) {
                    break;
                } // if

                cout << "Apellido: ";
                std::getline( cin, apel );

                if ( pNom->estaEnNomina( nomb, apel ) ) {
                    cerr << ERR_Y;
                } else {
                    cout << "Horas: ";
                    ( cin >> horas ).get();
                    pNom->entrarRecord( nomb, apel, horas );
                } // if-else
            } // while
            break;
        case contar:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
            } else {
                ( 1 == n )
                    ? cout << "Hay un record.\n\n"
                    : cout << "Hay " << n << " records.\n\n";
            } // if-else
            break;
        case crear:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
                break;
            } // if

            system( "cls" );
            FMT( std::cout, pNom->head ); // a consola

            try {
                FMT( Escribir, pNom->head ); // a disco
                cout << "N\242mina en disco.\n\n";
            } catch ( Str ) {
                std::cout << ERR_A;
            } // try-catch
            break;
        case editar:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
            } else {
                cout << "Nombre: ";
                std::getline( cin, nomb );
                cout << "Apellido: ";
                std::getline( cin, apel );

                if ( pNom->estaEnNomina( nomb, apel ) ) {
                    cout << "Horas: ";
                    ( cin >> horas ).get();
                    pNom->editarRecord( nomb, apel, horas );
                    cout << "Horas cambiadas.\n\n";
                } else {
                    cerr << ERR_N;
                } // if-else
            } // if-else
            break;
        case borrar:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
            } else {
                cout << "Nombre: ";
                std::getline( cin, nomb );
                cout << "Apellido: ";
                std::getline( cin, apel );

                if ( pNom->estaEnNomina( nomb, apel ) ) {
                    pNom->borrarRecord( nomb, apel );
                    cout << "Registro eliminado.\n\n";
                } else {
                    cerr << ERR_N;
                } // if-else
            } // if-else
            break;
        case cargar:
            try {
                pNom->subirRecords();
                cout << "Los registros fueron insertados.\n\n";
            } catch ( Str ) {
                std::cout << ERR_A;
            } // try-catch
            break;
        case vaciar:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
            } else {
                std::string sn;
                cout << "\255Esta operaci\242n no se puede deshacer!\n"
                     << "\250Prosigo? (s/n)";
                cin >> sn;
                if ( 'S' == toupper( sn[0] ) ) {
                    pNom->vaciarNomina();
                    std::cerr << "\255Hecho!\n\n";
                } // if
            } // if-else
            break;
        case checar:
            if ( pNom->estaVacia() ) {
                cerr << ERR_V;
            } else {
                cout << "Nombre: ";
                std::getline( cin, nomb );
                cout << "Apellido: ";
                std::getline( cin, apel );
                ( pNom->estaEnNomina( nomb, apel ) ) ? cout << ERR_Y : cerr << ERR_N;
            } // if-else
            break;
        } // switch

        system( "pause" );
    } // while
}
