#ifndef NOMINA_H_INCLUDED
#define NOMINA_H_INCLUDED

//  nomina.h: declaraciones para el ejercicio 40, noveno bloque
//  Fecha: 16/8/2019; 12:20 pm
//  Revisin: 6/9/2020; 8:30 am
//  Por S. Galliano.

#include "obrero.h"
typedef Obrero Item;

const Str ERR_A( "No pude abrir el fichero - regresando.\n\n" );
const Str ERR_V( "N\242mina vac\241a.\n\n" );
const Str ERR_N( "No est\240 en la n\242mina.\n\n" );
const Str ERR_Y( "Est\240 en la n\242mina.\n\n" );

struct Nomina {
    // constructor
    Nomina();
    // mtodos
    bool estaEnNomina ( Str nom, Str ape        ) const;
    void borrarRecord ( Str nom, Str ape        );
    void entrarRecord ( Str nom, Str ape, int hs );
    void editarRecord ( Str nom, Str ape, int hs );
    void subirRecords ();
    void vaciarNomina ();
    int contarRecords () const;
    bool estaVacia    () const;
    //  miembros
    int n;                // cantidad de nodos
    Item item;            // valor de un nodo
    struct Nomina * head; // la cabeza de la lista
    struct Nomina * prox; // puntero al prximo nodo
};

std::ostream & FMT( std::ostream & flujo, Nomina * pHead );

#endif // NOMINA_H_INCLUDED
