/*
	Programa p12:

	Descripcin: se requiere elevar un nmero cualquiera a una
	potencia entera. Se conoce que a elavada a n se puede calcular
	como a multiplicada por si misma, n veces; en este caso a es la
	base real y n el exponente entero. Codificar un programa modular
	que realice esta tarea y calcule la exponenciacin recursivamente

	Fecha: 7:39 jueves, 11 de abril de 2019
	Revisin: 26/12/2019; 7:43 pm
	S. Galliano.
*/

#include <iostream>
#include <cstdlib>
#include <cassert>

//  el nuevo nombre slo es un apodo
typedef unsigned short uShort;

//  prototipos de los dos mdulos principales:
void entrarDatos( double & base, uShort & exponente );     // entrada de datos
double calcularRespuesta( double base, uShort exponente ); // funcin de clculo

int main() {
    //  la variables se declaran fuera del ciclo
    double laBase, laRespuesta;
    uShort elExponente;
    char sn;
    std::cout << "Programa 12: potencia un n\243mero recursivamente.\n\n";

    while ( true ) {
        entrarDatos( laBase, elExponente );
        laRespuesta = calcularRespuesta( laBase, elExponente );

        std::cout << "Respuesta = " << laRespuesta
                  << "\n\n\250Una vez m\240s? (s/n) > ";
        std::cin >> sn;

        if ( 'N' == toupper( sn ) ) {
            return EXIT_SUCCESS;
        } // if-else

    } // while
}

//  entrada: entra la base y el exponente
void entrarDatos ( double & base, uShort & exponente ) {
    //  entra la base
    std::cout << "Escriba el n\243mero: ";
    std::cin >> base;

    //  entra el exponente
    std::cout << "Escriba el exponente entero: ";
    std::cin >> exponente;

    //  se asegura de que el exponente sea mayor o igual a cero
    assert ( exponente >= 0 );
}

//  eleva la base al exponente, recursivamente
double calcularRespuesta ( double base, uShort exponente ) {
    return ( 0 == exponente )
           ? 1
           : base * calcularRespuesta( base, exponente - 1 );
}
