// Programa 13: sobrecarga de funciones
// Fecha: 8:27 jueves, 11 de abril de 2019
// Revisin: 29/8/2020; 5:23 pm
// S. Galliano.

#include <iostream>
#include <cstdlib>
#include <string>
#include <ctime>    //  para clock_t
#include <cstring>  //  para strcpy(), strtok()

//  imprime(): imprime la hora
//  input: dos enteros hora y minuto
//  output: la hora a consola
void imprime ( clock_t hora, clock_t minuto );

//  imprime(): imprime la hora
//  input: una cadena clsica
//  output: la hora a consola
void imprime ( char * hora );

//  imprime(): imprime la hora
//  input: una cadena C++
//  output: la hora a consola
void imprime ( std::string hora );

int main() {
    //  informacin:
    std::cout <<
    "Programa 13: sobrecargando funciones.\n\n"
    "Este programa muestra 3 formas de tomar\n"
    "la hora para ponerla en consola:\n\n"
    "1) cadena C:\t25:44 (mal formato)\n"
    "2) cadena C++:\t 9:45 (por la ma\244ana)\n"
    "3) n\243meros:\t21,46 (por la tarde)\n\n";

    //  hora clsica;
    const short SIZE = 6;           // tamao mximo
    char hora1[SIZE];               // variable
    std::strcpy ( hora1, "25:44" ); // valor errneo: no hay hora 25
    std::cout << "1) cadena C:\t";	// informacin
    imprime( hora1 );               // respuesta

    //  cadena del C++
    std::string hora2( "9:45" );     // variable + valor
    std::cout << "2) cadena C++:\t"; // informacin
    imprime( hora2 );                // respuesta

    //  enteros en directo
    std::cout << "3) n\243meros:\t";
    imprime( 21, 46 ); // variable + respuesta
    std::cout << '\n';

    system( "pause" );
    return EXIT_SUCCESS;
}

//  esta funcin imprime la hora en formato h:m y cuenta con programacin
//  defensiva tipo OOP: cualquier valor extrao pone la hora a cero
void imprime( clock_t h, clock_t m ) {
    //  se comprueban los lmites
    if ( (h < 0 or h > 24) or   // mal hora o ...
         (m < 0 or m > 60) ) {  // ... mal minuto ...
        h = m = 0;              // ... todo a cero
    } // if

    std::string meridiano(" am"); // fija el meridiano en la maana

    // si la hora es ms de 12, le quita 12 y arregla el meridiano
    if ( h > 12 ) {
        h -= 12;
        meridiano = " pm";
    } // if

    //  saca a consola
    std::cout << h << ":" << m << meridiano << "\n";
}

//  se usa la funcin strtok() que extrae tokens, para poder separar
//  las horas de los minutos; cada uno de esos tokens se pasa a un
//  valor con atoi() antes de enviarlo a la impresin numrica
void imprime( char * hora ) {
    // as el delimitador que usa strtok (fjese en el *):
    const char * delim = ":"; // un puntero al delimitador; pueden ser varios

    // se desmiembra manualmente la palabra en caracteres numricos:
    // se fija el primer token, se pasa a atoi() y se guarda como hora
    clock_t hh = atoi(strtok(hora, delim ));
    // se fija el otro token, se pasa a atoi() y se guarda como minuto
    clock_t mm = atoi(strtok(nullptr, delim));

    //  los nmeros se pasan a la impresin numrica
    imprime( hh, mm );
}

//  se pasa la cadena de C++ para una ANSI C constante con la funcin
//  cadena.c_str() y se le remueve la constancia con el encasillamiento
//  y se pasa a la impresin de cadena clsica
void imprime( std::string hora ) {
    imprime( const_cast<char *>(hora.c_str()) );
}
