//  hora.cpp: definiciones para el programa 14
//  Fecha: 31/7/2019; 11:30 pm
//  Revisin: 26/12/2019; 8:30 pm
//  Por S. Galliano.

#include "hora.h"
#include <cstring>  //  para strcpy(), strtok()
#include <cstdlib>  //  para atoi()
#include <iostream> // para cout

// esta funcin imprime la hora en formato h:m y cuenta con programacin
// defensiva tipo OOP: cualquier valor extrao pone la hora a cero
void imprime( clock_t h, clock_t m ) {
    //  se comprueban los lmites
    if ( (h < 0 or h > 24) or   // mala hora o ...
         (m < 0 or m > 60) ) {  // ... mal minuto ...
        h = m = 0;              // ... todo a cero
    } // if

    std::string meridiano(" am"); // fija el meridiano en la maana

    // si la hora es ms de 12, le quita 12 y arregla el meridiano
    if ( h > 12 ) {
        h -= 12;
        meridiano = " pm";
    } // if

    //  saca a consola
    std::cout << h << ":" << m << meridiano << "\n";
}

// se usa la funcin strtok() que extrae tokens, para poder separar
// las horas de los minutos; cada uno de esos tokens se pasa a un
// valor con atoi() antes de enviarlo a la impresin numrica
void imprime( char * hora ) {
    // as se asigna el delimitador que usa strtok (fjese en el *):
    const char * delim = ":"; // un puntero al delimitador

    // se desmiembra manualmente la palabra en caracteres numricos:
    // se fija el primer token, se pasa a atoi() y se guarda como hora
    clock_t hh = atoi(strtok(hora, delim ));
    // se fija el otro token, se pasa a atoi() y se guarda como minuto
    clock_t mm = atoi(strtok(nullptr, delim));

    imprime( hh, mm ); // los nmeros a la impresin numrica
}

//  se pasa la cadena de C++ para una ANSI C constante con la funcin
//  cadena.c_str() y se le remueve la constancia con el encasillamiento
void imprime( std::string hora ) {
    imprime( const_cast<char *>(hora.c_str()) );
}
