//  promedio.cpp: definiciones para el programa 16:
//  Fecha: 9:30 domingo, 14 de abril de 2019
//  Por S. Galliano.

#include "promedio.h"
#include <iostream>
#include <iomanip>
using std::cout;
using std::setw;
using std::setprecision;
using std::fixed;

//  pone una lnea doble o simple en consola
void ponerLinea(bool doble) {
    ( true == doble )
        ? cout << std::setfill( '=' )
        : cout << std::setfill( '-' );
    cout << setw(8 * (COLS + 2)) << '\n';
}

//  muestra la tabla y su promedios
void mostrar(const int tabla[][COLS], int n) {
    cout <<  "Tabla de resultados.\n";
    //  encabezamiento de la tabla
    ponerLinea();
    cout << "Asig.\tMat.\tEsp.\tF\241s.\tQu\241.\tIng.\tBio.\tProm.\n";
    ponerLinea(false);
    //  cuerpo de la tabla
    double total = 0;
    cout << setprecision(1) << fixed;

    for (int i = 0; i < n; ++i) {
        cout << "Al. " << i + 1;

        for (int j = 0; j < COLS; ++j) {
            cout << '\t' << tabla[i][j];
            total += tabla[i][j];
        } // for

        cout << '\t' << total / COLS << '\n';
        total = 0;
    } // for

    //  promedio de las notas
    ponerLinea(false);
    cout << "Prom.";

    for (int i = 0; i < COLS; ++i) {
        for (int j = 0; j < FILS; ++j) {
            total += tabla[j][i];
        } // for j

        cout << '\t' << total / FILS;
        total = 0;
    } // for i

    cout << '\n';
    ponerLinea();
}
