//  cafeteria.cpp: definiciones para el programa p18:
//  Fecha: 14:48 domingo, 14 de abril de 2019
//  Revisin: 29/82020; 7:45 pm
//  Por S. Galliano.

#include "cafeteria.h"
#include <iostream>
#include <iomanip>
using std::cout;
using std::cin;
using std::setw;

//  construye una instancia de la cafeteria, con tres productos
Cafeteria::Cafeteria( Str nRef, float pRef,
                      Str nHel, float pHel,
                      Str nDul, float pDul,
                      Str nomb ) {
    // primero los de la clase
    nombre = nomb;
    estaHecho = false;
    // luego los valores agregados
    refresco.nombre = nRef; refresco.precio = pRef;
    helado.nombre   = nHel; helado.precio   = pHel;
    dulce.nombre    = nDul; dulce.precio    = pDul;
}

//  muestra las ofertas
void Cafeteria::mostrarMenu() {
    cout << '\n' << nombre << " - Men\243.\n\n" << std::left <<
    setw(10) << "Oferta" << "Precio\n";
    refresco.mostrarProducto();
    helado.mostrarProducto();
    dulce.mostrarProducto();
    cout << '\n';
}

//  toma las ventas y la recaudacin del da
void Cafeteria::tomarVenta() {
    cout << '\n' << nombre << "  -  Ventas del d\241a:\n";
    cout << refresco.nombre << "? ";
    cin  >> refresco.cantidad;
    refresco.recaudo = refresco.cantidad * refresco.precio;
    cout << helado.nombre << "? ";
    cin  >> helado.cantidad;
    helado.recaudo = helado.cantidad * helado.precio;
    cout << dulce.nombre << "? ";
    cin  >> dulce.cantidad;
    dulce.recaudo = dulce.cantidad * dulce.precio;

    //  ya puede salir
    estaHecho = true;
    cout << '\n';
}

//  muestra la recaudacin calculada por demanda
void Cafeteria::mostrarRecaudo()  {
    //  encabezamiento
    cout << '\n' << nombre << " - Total ventas del d\241a:\n\n" <<
    std::fixed << std::setprecision(2) <<
    setw(10) << std::left  << "Oferta" <<
    setw(9)  << std::right << "Cant."  <<
    setw(8)  << "Precio"   <<
    setw(9)  << "Venta"    << '\n';

    //  tabla
    double total = 0, importe = 0;
    if ( refresco.recaudo > 0 ) {
        importe = refresco.recaudo;
        total += importe;
        cout <<
        setw(10) << std::left  << refresco.nombre <<
        setw(8)  << std::right << refresco.cantidad <<
        setw(9)  << refresco.precio <<
        setw(9)  << importe << '\n';
    } // if

    if ( helado.recaudo > 0 ) {
        importe = helado.recaudo;
        total += importe;
        cout <<
        setw(10) << std::left  << helado.nombre <<
        setw(8)  << std::right << helado.cantidad <<
        setw(9)  << helado.precio <<
        setw(9)  << importe << '\n';
    } // if

    if ( importe > 0 ) {
        importe = dulce.recaudo;
        total += importe;
        cout <<
        setw(10) << std::left  << dulce.nombre <<
        setw( 8) << std::right << dulce.cantidad <<
        setw( 9) << dulce.precio <<
        setw( 9) << importe << '\n';
    } // if

    //  pie
    cout << "Total " << std::setfill('.') << setw(30) << total  << "$\n";
}
