//  cafeteria.cpp: definiciones para el programa 23-a
//  Fecha: 1:16 jueves, 25 de abril de 2019
//  Revisado: 31/8/2020; 12:13 pm
//  Por S. Galliano.

#include "cafeteria.h"
#include <iostream>
#include <iomanip>
using std::cout;
using std::cin;
using std::setw;

//  construye una instancia de la cafeteria, con tres productos
Cafeteria::Cafeteria ( Str nRef, float pRef,
                       Str nHel, float pHel,
                       Str nDul, float pDul,
                       Str nomb ) {
    // primero los valores agregados
    refresco.nombre = nRef;
    refresco.precio = pRef;
    helado.nombre   = nHel;
    helado.precio   = pHel;
    dulce.nombre    = nDul;
    dulce.precio    = pDul;
    // luego los de la clase
    nombre = nomb;
    recaudacion = 0;
    estaHecho = false;
}

//  muestra las ofertas
void Cafeteria::mostrarMenu() {
    cout << nombre << " - Men\243.\n\n" << std::left <<
    setw(10) << "Oferta" << "Precio\n";
    refresco.mostrarProducto();
    helado.mostrarProducto();
    dulce.mostrarProducto();
    cout << '\n';
}

//  toma las ventas del da y calcula la recaudacin
void Cafeteria::tomarVenta() {
    cout << nombre << "  -  Ventas del d\241a:\n";
    cout << refresco.nombre << "? ";
    cin  >> refresco.cantidad;
    cout << helado.nombre << "? ";
    cin  >> helado.cantidad;
    cout << dulce.nombre << "? ";
    cin  >> dulce.cantidad;
    cout << '\n';
    // recaudacin del da
    recaudacion += refresco.cantidad * refresco.precio;
    recaudacion += helado.cantidad   * helado.precio;
    recaudacion += dulce.cantidad    * dulce.precio;
    //  ya puede salir
    estaHecho = true;
}

//  muestra la recaudacin calculada por demanda
void Cafeteria::mostrarRecaudo() {
    if ( 0 == recaudacion ) {
        cout << "No hubo ventas hoy.\n\n";
    } else {
        double importe;
        cout << nombre << " - Total ventas del d\241a:\n\n";
        //  encabezamiento
        cout << std::fixed << std::setprecision(2) <<
        setw(10) << std::left  << "Oferta" <<
        setw( 8) << std::right << "Cant." <<
        setw( 9) << "Precio"   <<
        setw( 9) << "Venta"    << '\n';
        //  tabla
        importe = refresco.cantidad * refresco.precio;
        cout <<
        setw(10) << std::left  << refresco.nombre <<
        setw( 8) << std::right << refresco.cantidad <<
        setw( 9) << refresco.precio <<
        setw( 9) << importe << '\n';

        importe = helado.cantidad * helado.precio;
        cout <<
        setw(10) << std::left  << helado.nombre <<
        setw( 8) << std::right << helado.cantidad <<
        setw( 9) << helado.precio <<
        setw( 9) << importe << '\n';

        importe = dulce.cantidad *  dulce.precio;
        cout <<
        setw(10) << std::left  << dulce.nombre <<
        setw( 8) << std::right << dulce.cantidad <<
        setw( 9) << dulce.precio <<
        setw( 9) << importe << '\n';

        //  pie
        cout << "Total " << std::setfill('.') <<
        setw(30) << recaudacion  << "$\n";
    } // if-else
}
