//  lse.cpp: definiciones para el programa 24
//  Fecha: 01/07/2019; 8:28 am
//  Revisin: 14/5/2020; 7 pm
//  Por S. Galliano

#include "lse.h"
#include <iostream>
#include <cstdlib>
using std::cout;
typedef std::string Str;

Nodo::Nodo() {
    head = nullptr;
    prox = nullptr;
}

bool Nodo::estaVacia() const {
    return nullptr == head;
}

int Nodo::cuentame() const {
    int n = 0;

    for ( Nodo *p1 = head; p1 not_eq nullptr; p1 = p1->prox ) {
        n++;
    } // for

    return n;
}

bool Nodo::enLista(Item val) const {
    for ( Nodo *p1 = head; p1 not_eq nullptr; p1 = p1->prox ) {
        if ( val == p1->item ) {
            return true;
        } // if
    } // for

    return false;
}

bool Nodo::borraNodo(Item val) {
    bool hecho;

    if ( not enLista( val ) ) {
        hecho = false;
    } else {
        Nodo *p1 = head;
        Nodo *p2 = nullptr;

        // p1 viaja por la lista y p2 le sigue
        while ( p1->item not_eq val ) {
            p2 = p1;       // pone a p2 sobre el nodo a borrar
            p1 = p1->prox; // preserva la continuidad
        } // while

        if ( nullptr == p2 ) {
            head = p1->prox; // si es el 1er. nodo, lo desancla de la cabeza
        } else {
            p2->prox = p1->prox; // y es otro nodo, lo desancla de la lista
        } // if-else

        delete p1; // el nodo se elimina de memoria
        hecho = true;
    } // if-else

	return hecho;
}

void Nodo::vaciaLista() {
    Nodo *p1;

    while ( not estaVacia() ) {
        if ( head->prox == nullptr ) { //  lleg al final
            delete head;
            head = nullptr;
        } else { //  quedan nodos; sigue borrndolos
            p1 = head;
            head = p1->prox;
            delete p1;
        } // if-else
    } // while
}

void Nodo::adiciona(Item val, short pos) {
    Nodo *p1 = head, *p2 = nullptr;
	Nodo *nuevo = new Nodo;
	nuevo->item = val; // toma el valor

    // pone a p2 en la posicin de insercin
    // y p1 preserva la continuidad
    for (int i = 0; i < pos and p1 not_eq nullptr; i++) {
        p2 = p1;
        p1 = p1->prox;
    } // for

    nuevo->prox = p1;  // se pone en posicin

    if ( p2 == nullptr ) {
        head = nuevo;     // se pone a la cabeza
    } else {
        p2->prox = nuevo; // se enlaza a la lista
    } // if-else
}

void Nodo::muestrame() const {
    cout << "Lista: ";

    for ( Nodo *p1 = head; p1 not_eq nullptr; p1 = p1->prox ) {
        cout << p1->item << ", ";
    } // for

    cout << "\b\b \n\n"; // quita la coma final
}
