/*
	Programa 24: LSE como estructura C++

	Descripcin: se pide manejar por men, un listado de enteros mediante
	una LSE. El programa debe ser capaz de crear una lista, insertar un
	nodo en una posicin dada, enumerar los nodos, buscar un valor en la
	lista, imprimirla, eliminar un nodo con determinado valor y vaciarla.
	En el men habr una opcin para pedir ayuda acerca de las operaciones.

	Fecha: 01/07/2019; 8:28 am
	Revisin: 14/5/2020; 7 pm
	S. Galliano.
*/

#include "menu.h"
#include "lse.h"
#include <iostream>
#include <cstdlib>
#include <string>

int main() {
    std::string info("Programa 24: manejo de una LSE.\n\n");
    Nodo *head = new Nodo; // la lista en la tienda libre
    short opcion;
    Item valor, pos, n;

    while (true) {
        opcion = menu(info);

        if ( terminar == opcion ) {
            if ( not head->estaVacia() ) {
                head->vaciaLista();
            } // if

            delete head;
            return EXIT_SUCCESS;
        } // if

        switch(opcion) {
        case ayudar:
            darAyuda(info);
            break;
        case insertar:
            std::cout << "\250Valor? ";
            (std::cin >> valor).get();

            if ( head->enLista(valor) ) {
                std::cout << "Ya est\240.\n\n";
            } else {
                std::cout << "(0 a la cabeza) \250Posici\242n? ";
                (std::cin >> pos).get();
                if ( 0 == pos ) {
                    head->adiciona(valor, 0);
                } else {
                    head->adiciona(valor, --pos);
                } // if-else
                std::cout << HECHO;
            } // if-else
            break;
        case enumerar:
            if ( head->estaVacia() ) {
                std::cout << WARN;
            } else {
                n = head->cuentame();
                ( 1 == n )
                ? std::cout << "Un nodo.\n\n" : std::cout << n << " nodos.\n\n";
            } // if-else
            break;
		case buscar:
            if ( head->estaVacia() ) {
                std::cout << WARN;
            } else {
                std::cout << "\250Valor? ";
                (std::cin >> valor).get();
                ( head->enLista(valor) )
                    ? std::cout << "Ya est\240.\n\n"
                    : std::cout << "No est\240.\n\n";
            } // if-else
            break;
        case imprimir:
            if ( head->estaVacia() ) {
                std::cout << WARN;
            } else {
                head->muestrame();
            } // if-else
            break;
        case eliminar:
            if ( head->estaVacia() ) {
                std::cout << WARN;
            } else {
                std::cout << "\250Valor? ";
                (std::cin >> valor).get();
                ( head->borraNodo(valor) )
                    ? std::cout << "HECHO"
                    : std::cout << "FALLO";
            } // if-else
            break;
        case vaciar:
            if ( head->estaVacia() ) {
                std::cout << WARN;
            } else {
                char procedo;
                std::cout << "Esta operaci\242n destruir\240 la lista.\n"
                             "\250Procedo? (s/n) ";
                std::cin >> procedo;

                if ( 'S' == toupper(procedo) ) {
                    head->vaciaLista();
                    std::cout << HECHO;
                } // if
            } // if-else
            break;
        } // switch

        system("pause");
    } // while
}
