// binary_search.cpp: definiciones para el programa
// Fecha: 9:39 martes, 30 de abril de 2019
// Revisin: 31/8/2020; 5:20 pm
// Por S. Galliano.

#include "binary_search.h"
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <iomanip>
using std::cout;

//  funcin de comparacin de enteros
int compInt( const void * p, const void * q ) {
    int m = *static_cast<const int *>( p );
    int n = *static_cast<const int *>( q );
    if( m > n ) {
        return 1;
    } else if( m < n ) {
        return -1;
    } else {
        return 0;
    }
}

//  genera un arreglo de n enteros, tomados al azar entre 1 y 100
void generaValores( int * pAry, int n ) {
    srand( time( 0 ) );

    for( int i = 0; i < n; i++ ) {
        pAry[i] = 1 + rand() % 100;
    } // for
}


//  busca todas las posiciones de un valor en un arreglo de enteros
void lfind( const int * K, const int * pAry, int n ) {
    int j = 0, k = 0;

    for( int i = 0; i < n; ++i ) {
        if( pAry[i] < *K ) {
            ++k;   // donde comienzan a repetirse
        } else if( pAry[i] == *K ) {
            ++j;   // las repeticiones
        } else {
            break; // se acab la visita
        } // if-en-cascada
    } // for

    ( 1 == j ) // C++ cuenta el ndice, nosotros la posicin (una ms)
    ? cout << *K << " est\240 una vez en la posici\242n " << ++k
           : cout << *K << " est\240 " << j << " veces a partir de la posici\242n " << ++k;

    cout << "\n\n";
}

//  muestra el arreglo en cols columnas
void mostrar( const int * pAry, int n, int cols ) {
    for( int i = 0, columna = 1; i < n; ++i, ++columna ) {
        cout << pAry[i];
        ( 0 == columna % cols ) ? cout << '\n' : cout << '\t';
    } // for

    cout << '\n';
}
