//  entrada.cpp: definiciones para el programa 16
//  Fecha: 26/8/2019; 7:52 am
//  Revisin: 11/9/2020; 12:22 pm
//  Por S. Galliano.

#include "estads.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cmath>

//  funcin de comparacin
int compara( const void *p, const void *q ) {
    int m = *static_cast<const int *>( p );
    int n = *static_cast<const int *>( q );
    if ( m > n ) { return 1; }
    else if ( m < n ) { return -1; }
    else { return 0; }
}

//  valores ledos desde el archivo
void Estads::leerArchivo( const Str archy ) {
    // aqu hace falta cdigo defensivo, porque
    // si el fichero no est, no puede abrirlo
    std::ifstream Leyendo;
    Leyendo.open( archy );

    if ( Leyendo.is_open() ) {
        double val;
        int i = 0;

        while ( Leyendo >> val ) {
            ary[i] = val;
            ++i;
        } // while

        n = i;
        qsort( ary, n, sizeof( int ), compara );
    } else {
        throw ERROR;
    } // if-else
}

int Estads::suma() {
    int total = 0;

    for ( int i = 0; i < n; ++i) {
        total += ary[i];
    } // for

    return total;
}

double Estads::promedio() { return static_cast<double>(suma()) / n; }
int Estads::miMax() { return ary[n-1]; }
int Estads::miMin() { return ary[0]; }

double Estads::mediana() {
    double med;
    int idx = 0.5 * n; // se busc el ndice del medio
    n % 2              // se calcul la mediana
        ? med = ary[idx]
        : med = 0.5 * ( ary[idx - 1] + ary[idx] );
    return med;
}

// moda
int Estads::moda() {
    int unaModa = ary[0];      // el 1er. valor
    int laModa  = unaModa;     // la moda actual
    int unaRacha   = 0;        // la 1ra. racha
    int laRacha    = unaRacha; // el tamao de una racha
    int i          = 0;        // el ndice de la secuencia

    while ( i not_eq n ) {
        if ( unaModa not_eq ary[i] ) { // cambi la moda?
            unaModa = ary[i];          // SI: actualizarla

            if ( unaRacha > laRacha ) { // cambi la racha?
                laRacha = unaRacha;     // SI: actualizarla y...
                laModa  = ary[i - 1];   // ...actualizar la moda
            } // if-interior

            unaRacha = 0; // contar otra racha
        } // if-exterior
        ++unaRacha; // incrementa la racha
        ++i;        // incrementa el ndice
    } // while

    if ( 1 == laRacha ) {
        laModa = static_cast<int>(HUGE_VAL);
    } // if

    return laModa;
}

double Estads::varianza() {
    double total = 0.0;
    double ave = promedio();

    for (int i = 0; i < n; ++i) {
        total += pow( ary[i] - ave, 2.0 );  // se visitan los nodos
    } // for

    return total / ( n - 1 ); // varianza muestral
}

double Estads::desviacion() { return sqrt( varianza() ); }

void muestra( std::ostream & escribe, Str ID, const int & stat ) {
    escribe.setf( std::ios::fixed );

    if ( static_cast<int>(HUGE_VAL) == stat ) {
        escribe << "Moda = #N/A\n";
    } else {
        escribe << std::setw( 12 ) << ID << std::setw( 4 ) << stat << '\n';
    } // if-else

    escribe.unsetf( std::ios::fixed );
}

void muestra( std::ostream & escribe, Str ID, const double & stat ) {
    escribe.setf( std::ios::fixed );
    escribe << std::setprecision( 4 );
    escribe << std::setw( 12 ) << ID << std::setw( 9 ) << stat << '\n';
    escribe.unsetf( std::ios::fixed );
    escribe << std::setprecision( 6 );
}
