// Programa 16: leyendo desde un archivo
// Fecha: 26/8/2019; 7:52 am
// Revisin: 11/9/2020; 12:22 pm
// S. Galliano.

#include "estads.h"
#include <iostream>
#include <fstream>

int main() {

    std::cout << "Programa 29: lee 200 n\243meros de un archivo\n"
                 "y calcula sus principales estad\241sticos\n\n";
    Estads est; // los estadsticos
    Str archy;  // nombre de los archivos de lectura y escritura
    std::cout << "Nombre del archivo a leer: ";
    std::cin >> archy;

    //  cdigo defensivo aqu
    try {
        std::cout << "Leyendo del archivo " << archy;
        est.leerArchivo( archy );
        std::cout << "...hecho.\n\n";
    } catch( Str ) {
        std::cout << ERROR;
        return EXIT_FAILURE;
    } // try-catch

    //  respuestas a consola
    std::cout << "Estad\241sticos a consola:\n\n";
    muestra( std::cout, "Media = ",     est.promedio()   );
    muestra( std::cout, "Mediana = ",   est.mediana()    );
    muestra( std::cout, "Moda = ",      est.moda()       );
    muestra( std::cout, "Varianza = ",  est.varianza()   );
    muestra( std::cout, "Desviac. = ",  est.desviacion() );
    muestra( std::cout, "M\240ximo = ", est.miMax()     );
    muestra( std::cout, "M\241nimo = ", est.miMin()     );
    muestra( std::cout, "Rango = ", est.miMax() - est.miMin() );
    muestra( std::cout, "Suma = ",  est.suma() );
    muestra( std::cout, "Cuenta = ", est.n );
    std::cout << "\n";

    //  respuestas al disco
    std::cout << "Nombre del archivo a escribir: ";
    std::cin >> archy;

    // un flujo de salida
    std::ofstream Escribiendo;
    Escribiendo.open( archy );

    if ( Escribiendo.is_open() ) {
        std::cout << "Escribiendo al archivo " << archy;
        muestra( Escribiendo, "Media = ",     est.promedio()   );
        muestra( Escribiendo, "Mediana = ",   est.mediana()    );
        muestra( Escribiendo, "Moda = ",      est.moda()       );
        muestra( Escribiendo, "Varianza = ",  est.varianza()   );
        muestra( Escribiendo, "Desviac. = ",  est.desviacion() );
        muestra( Escribiendo, "M\240ximo = ", est.miMax()     );
        muestra( Escribiendo, "M\241nimo = ", est.miMin()     );
        muestra( Escribiendo, "Rango = ", est.miMax() - est.miMin() );
        muestra( Escribiendo, "Suma = ",  est.suma() );
        muestra( Escribiendo, "Cuenta = ", est.n );
        std::cout << "...hecho.\n\n";
    } else {
        std::cout << ERROR;
        return EXIT_FAILURE;
    } // if-else

    system( "pause" );
    return EXIT_SUCCESS;
}
