//  fileio.cpp: definiciones para el programa 31
//  Fecha: 7:18 jueves, 2 de mayo de 2019
//  Por S. Galliano.

#include "fileio.h"
#include "estads.h"
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <iomanip>

//  entrada de datos desde un archivo:

//  esta funcin escribe los valores del arreglo pAry al archivo archy
void escribeArchivo ( std::string archy, const double * pAry, int n ) {
    std::ofstream bufferOut ( archy );
    const int WIDE = 9;
    if ( bufferOut.good() ) {
        bufferOut << std::fixed << std::right << std::setprecision ( 4 ) <<
        " Media    = " << std::setw ( WIDE ) << promedio ( pAry, n )   << '\n' <<
        " Mediana  = " << std::setw ( WIDE ) << mediana ( pAry, n )    << '\n' <<
        " Moda     = " << std::setw ( WIDE ) << moda ( pAry, n )       << '\n' <<
        " Varianza = " << std::setw ( WIDE ) << varianza ( pAry, n )   << '\n' <<
        " Desviac. = " << std::setw ( WIDE ) << desviacion ( pAry, n ) << '\n' <<
        " M\240ximo   = " << std::setw ( WIDE ) << maximo ( pAry, n )  << '\n' <<
        " M\241nimo   = " << std::setw ( WIDE ) << minimo ( pAry, n )  << '\n' <<
        " Rango    = " << std::setw ( WIDE ) << rango ( pAry, n )      << '\n' <<
        " Suma     = " << std::setw ( WIDE ) << suma ( pAry, n )       << '\n' <<
        " Cuenta   = " << std::setw ( WIDE - 5 ) << n                 << '\n';
    } else {
        std::cerr << "No pude abrir el fichero - abortando.\n\n";
        system ( "pause" );
        exit ( EXIT_FAILURE );
    } // if-else
}

//  genera un arreglo de n dobles, tomados al azar
void generaValores ( double * pAry, int n ) {
    srand ( time ( 0 ) ); // una semilla aleatoria
    for ( int i = 0; i < n; i++ ) {
        pAry[i] = 0.01 * ( 1 + rand() % 100 );
    } // for;
}

//  salida de informacin a un archivo:

//  cuenta los datos del archivo para poder definirlo luego,
//  en la tienda libre; de paso comprueba si se abri
int cuentaDatos ( std::string archy ) {
    std::ifstream bufferIn ( archy );
    int i = 0;
    if ( bufferIn.good() ) {
        float data;
        while ( bufferIn.good() ) {
            bufferIn >> data;
            ++i;
        } // while
        return --i; // elimina la ltima linea en blanco
    } else {
        std::cerr << "No pude abrir el fichero - abortando.\n\n";
        system ( "pause" );
        i = EXIT_FAILURE;
    } // if-else
    return i;
}

//  lee los valores del archivo y los pone en el arreglo pAry
void leeArchivo ( std::string archy, double * pAry, int n ) {
    std::ifstream bufferIn ( archy );
    if ( bufferIn.good() ) {
        for ( int i = 0; i < n; ++i ) {
            bufferIn >> pAry[i]; //  leyendo datos
        } // for
    } else {
        std::cerr << "No pude abrir el fichero - abortando.\n\n";
        system ( "pause" );
        exit ( EXIT_FAILURE );
    } // if-else
}
