// Programa p30: parmetros en la lnea de comandos.
#include "../p29-leyendo/entrada.h"
#include "../p29-leyendo/estads.h"
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <iomanip>

int main( int argc, char *argv[] ) {
    if ( argc not_eq 3 ) {
        std::cerr <<
        "Uso: p30 entrada.txt salida.txt\n"
        "  entrada: nombre del fichero con los datos.\n"
        "  salida : nombre del fichero con la informaci\242n.\n"
        "  Si el fichero de salida existe, se sobrescribe; si no, se crea.\n";
        return EXIT_FAILURE;
    } // if

    // info
    std::cout << "Programa 30: interactuando con el DOS\n\n"
    "Lee los n\243meros del archivo \"" << argv[1] << "\", "
    "calcula sus principales\nestad\241sticos y los pone en "
    "el archivo \"" << argv[2] << "\"\n\n";

    // nombre de los archivos
    std::string archy1 = argv[1]; // de datos
    std::string archy2 = argv[2]; // de respuesta
    int n;

    //  la entrada
    try {
        n = contarDatos(archy1);
    } catch (Str) {
        std::cout << ERR;
        return EXIT_FAILURE;
    } // try-catch

    std::cout << "Leyendo de " << archy1 << "...";	// trayendo los datos al arreglo
    double *pAry = new double[n];            	// los valores en la tienda gratis
    leerArchivo(archy1, pAry, n);            	// llenando al arreglo
    qsort(pAry, n, sizeof(double), compara); 	// ordenando el arreglo
    std::cout << "hecho.\nEscribiendo en "<< archy2 << "...";
    std::ofstream Escribiendo(archy2);

    try {
        if ( Escribiendo.fail() ) {
            throw ERR;
        } // if
    } catch (Str) {
        std::cout << ERR;
        return EXIT_FAILURE;
    } // try-catch

    std::cout << "hecho.\n";

    //	fin
    delete [] pAry;
    return EXIT_SUCCESS;
}
